diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/helper/ns2-mobility-helper.cc ns-3.38/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.37/src/mobility/helper/ns2-mobility-helper.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/helper/ns2-mobility-helper.cc	2023-03-16 20:54:23.792869000 -0700
@@ -178,7 +178,7 @@
 /**
  * Check if this corresponds to a line like this: $ns_ at 1 "$node_(0) setdest 2 3 4"
  * \param pr the ParseResult to analyze
- * \returns true if the ParseResult looks like a coordinate with a scheduled time and destionation
+ * \returns true if the ParseResult looks like a coordinate with a scheduled time and destination
  */
 static bool IsSchedSetPos(ParseResult pr);
 
@@ -591,12 +591,12 @@
 {
     std::string ret = s;
 
-    while (ret.size() > 0 && isblank(ret[0]))
+    while (!ret.empty() && isblank(ret[0]))
     {
         ret.erase(0, 1); // Removes blank spaces at the beginning of the line
     }
 
-    while (ret.size() > 0 && (isblank(ret[ret.size() - 1]) || (ret[ret.size() - 1] == ';')))
+    while (!ret.empty() && (isblank(ret[ret.size() - 1]) || (ret[ret.size() - 1] == ';')))
     {
         ret.erase(ret.size() - 1, 1); // Removes blank spaces from at end of line
     }
@@ -616,7 +616,7 @@
 bool
 IsVal(const std::string& str, T& ret)
 {
-    if (str.size() == 0)
+    if (str.empty())
     {
         return false;
     }
@@ -746,7 +746,7 @@
 IsSetInitialPos(ParseResult pr)
 {
     //        number of tokens         has $node_( ?                        has "set"           has
-    //        doble for position?
+    //        double for position?
     return pr.tokens.size() == 4 && HasNodeIdNumber(pr.tokens[0]) && pr.tokens[1] == NS2_SET &&
            pr.has_dval[3]
            // coord name is X_, Y_ or Z_ ?
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/model/position-allocator.cc ns-3.38/src/mobility/model/position-allocator.cc
--- ns-3.37/src/mobility/model/position-allocator.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/model/position-allocator.cc	2023-03-16 20:54:23.792869000 -0700
@@ -232,7 +232,7 @@
 }
 
 void
-GridPositionAllocator::SetLayoutType(enum LayoutType layoutType)
+GridPositionAllocator::SetLayoutType(LayoutType layoutType)
 {
     m_layoutType = layoutType;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/model/position-allocator.h ns-3.38/src/mobility/model/position-allocator.h
--- ns-3.37/src/mobility/model/position-allocator.h	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/model/position-allocator.h	2023-03-16 20:54:23.792869000 -0700
@@ -178,7 +178,7 @@
     /**
      * \param layoutType the type of layout to use (row first or column first).
      */
-    void SetLayoutType(enum LayoutType layoutType);
+    void SetLayoutType(LayoutType layoutType);
 
     /**
      * \return the x coordinate of the first allocated position.
@@ -203,20 +203,20 @@
     /**
      * \return the currently-selected layout type.
      */
-    enum LayoutType GetLayoutType() const;
+    LayoutType GetLayoutType() const;
 
     Vector GetNext() const override;
     int64_t AssignStreams(int64_t stream) override;
 
   private:
-    mutable uint32_t m_current;   //!< currently position
-    enum LayoutType m_layoutType; //!< currently selected layout type
-    double m_xMin;                //!< minimum boundary on x positions
-    double m_yMin;                //!< minimum boundary on y positions
-    double m_z;                   //!< z coordinate of all the positions generated
-    uint32_t m_n;                 //!< number of positions to allocate on each row or column
-    double m_deltaX;              //!< x interval between two consecutive x positions
-    double m_deltaY;              //!< y interval between two consecutive y positions
+    mutable uint32_t m_current; //!< currently position
+    LayoutType m_layoutType;    //!< currently selected layout type
+    double m_xMin;              //!< minimum boundary on x positions
+    double m_yMin;              //!< minimum boundary on y positions
+    double m_z;                 //!< z coordinate of all the positions generated
+    uint32_t m_n;               //!< number of positions to allocate on each row or column
+    double m_deltaX;            //!< x interval between two consecutive x positions
+    double m_deltaY;            //!< y interval between two consecutive y positions
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/model/random-walk-2d-mobility-model.h ns-3.38/src/mobility/model/random-walk-2d-mobility-model.h
--- ns-3.37/src/mobility/model/random-walk-2d-mobility-model.h	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/model/random-walk-2d-mobility-model.h	2023-03-16 20:54:23.792869000 -0700
@@ -84,7 +84,7 @@
 
     ConstantVelocityHelper m_helper;       //!< helper for this object
     EventId m_event;                       //!< stored event ID
-    enum Mode m_mode;                      //!< whether in time or distance mode
+    Mode m_mode;                           //!< whether in time or distance mode
     double m_modeDistance;                 //!< Change direction and speed after this distance
     Time m_modeTime;                       //!< Change current direction and speed after this delay
     Ptr<RandomVariableStream> m_speed;     //!< rv for picking speed
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/model/steady-state-random-waypoint-mobility-model.h ns-3.38/src/mobility/model/steady-state-random-waypoint-mobility-model.h
--- ns-3.37/src/mobility/model/steady-state-random-waypoint-mobility-model.h	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/model/steady-state-random-waypoint-mobility-model.h	2023-03-16 20:54:23.792869000 -0700
@@ -38,7 +38,7 @@
  * The difference is that the initial values of this parameters are not
  * from uniform distribution but from stationary distribution of RWM model.
  * The implementation of this model is 2D-specific and with nonzero nodes speeds.
- * In the 3D ns-3 coordinate system, the momement occurs on the
+ * In the 3D ns-3 coordinate system, the movement occurs on the
  * \f$ z=\overline{Z} \f$ plane, where \f$ \overline{Z} \f$ is a constant which
  * can be configured using the Z attribute.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/geo-to-cartesian-test.cc ns-3.38/src/mobility/test/geo-to-cartesian-test.cc
--- ns-3.37/src/mobility/test/geo-to-cartesian-test.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/geo-to-cartesian-test.cc	2023-03-16 20:54:23.792869000 -0700
@@ -1689,7 +1674,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Cartesian to Geo Test Case
  *
@@ -1806,7 +1790,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Geo To Cartesian Test Suite
  */
@@ -1891,4 +1874,8 @@
     }
 }
 
+/**
+ * \ingroup mobility-test
+ * Static variable for test initialization
+ */
 static GeoToCartesianTestSuite g_GeoToCartesianTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/mobility-test-suite.cc ns-3.38/src/mobility/test/mobility-test-suite.cc
--- ns-3.37/src/mobility/test/mobility-test-suite.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/mobility-test-suite.cc	2023-03-16 20:54:23.792869000 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Test whether course change notifications occur regardless of calls
  * to Update() position (which are triggered by calls to GetPosition())
@@ -113,7 +112,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Waypoint Lazy Notify True
  */
@@ -188,7 +186,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Waypoint Initial Position Is Waypoint Test
  */
@@ -382,7 +379,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Waypoint Mobility Model Via Helper Test
  */
@@ -478,7 +474,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Mobility Test Suite
  */
@@ -497,4 +492,8 @@
     AddTestCase(new WaypointMobilityModelViaHelper, TestCase::QUICK);
 }
 
-static MobilityTestSuite mobilityTestSuite; ///< the test suite
+/**
+ * \ingroup mobility-test
+ * Static variable for test initialization
+ */
+static MobilityTestSuite mobilityTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/mobility-trace-test-suite.cc ns-3.38/src/mobility/test/mobility-trace-test-suite.cc
--- ns-3.37/src/mobility/test/mobility-trace-test-suite.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/mobility-trace-test-suite.cc	2023-03-16 20:54:23.796869000 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Mobility Trace Test Case
  */
@@ -114,7 +113,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Mobility Trace Test Suite
  */
@@ -131,4 +129,8 @@
     AddTestCase(new MobilityTraceTestCase, TestCase::QUICK);
 }
 
-static MobilityTraceTestSuite mobilityTraceTestSuite; ///< the test suite
+/**
+ * \ingroup mobility-test
+ * Static variable for test initialization
+ */
+static MobilityTraceTestSuite mobilityTraceTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/ns2-mobility-helper-test-suite.cc ns-3.38/src/mobility/test/ns2-mobility-helper-test-suite.cc
--- ns-3.37/src/mobility/test/ns2-mobility-helper-test-suite.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/ns2-mobility-helper-test-suite.cc	2023-03-16 20:54:23.796869000 -0700
@@ -76,7 +76,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Every test case is supposed to:
  *  1. Generate short mobility trace file
@@ -115,7 +114,7 @@
         /**
          * Less-than operator - used to sort by timestamp
          * \param o object to compare to
-         * \returns true if the timestamp of the 1nd operand is less than the other one's
+         * \returns true if the timestamp of the 1st operand is less than the other one's
          */
         bool operator<(const ReferencePoint& o) const
         {
@@ -203,7 +202,7 @@
     }
 
     /// Create and name nodes
-    void CreateNodes()
+    void CreateNodes() const
     {
         NodeContainer nodes;
         nodes.Create(m_nodeCount);
@@ -322,7 +321,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief The test suite
  */
@@ -510,7 +508,7 @@
         t->AddReferencePoint("0", 3, Vector(0, -1, 0), Vector(0, 0, 0));
         AddTestCase(t, TestCase::QUICK);
 
-        // Sqare setdest with values in the form 1.0e+2
+        // Square setdest with values in the form 1.0e+2
         t = new Ns2MobilityHelperTest("Foalt numbers in 1.0e+2 format", Seconds(6));
         t->SetTrace("$node_(0) set X_ 0.0\n"
                     "$node_(0) set Y_ 0.0\n"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/rand-cart-around-geo-test.cc ns-3.38/src/mobility/test/rand-cart-around-geo-test.cc
--- ns-3.37/src/mobility/test/rand-cart-around-geo-test.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/rand-cart-around-geo-test.cc	2023-03-16 20:54:23.796869000 -0700
@@ -57,7 +57,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Rand Cart Around Geo Test Case
  */
@@ -174,7 +173,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Rand Cart Around Geo Test Suite
  */
@@ -209,4 +207,8 @@
     }
 }
 
-static RandCartAroundGeoTestSuite g_RandCartAroundGeoTestSuite; ///< the test suite
+/**
+ * \ingroup mobility-test
+ * Static variable for test initialization
+ */
+static RandCartAroundGeoTestSuite g_RandCartAroundGeoTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc ns-3.38/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc
--- ns-3.37/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2023-03-16 20:54:23.796869000 -0700
@@ -30,7 +30,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Steady State Random Waypoint Test
  */
@@ -153,7 +152,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Steady State Random Waypoint Test Suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mobility/test/waypoint-mobility-model-test.cc ns-3.38/src/mobility/test/waypoint-mobility-model-test.cc
--- ns-3.37/src/mobility/test/waypoint-mobility-model-test.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mobility/test/waypoint-mobility-model-test.cc	2023-03-16 20:54:23.796869000 -0700
@@ -27,7 +27,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Waypoint Mobility Model Notify Test
  */
@@ -172,7 +171,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Waypoint Mobility Model Add Waypoint Test
  */
@@ -197,7 +195,7 @@
     void DoRun() override;
     void DoTeardown() override;
     /**
-     * Course change calback
+     * Course change callback
      * \param model the mobility model
      */
     void CourseChangeCallback(Ptr<const MobilityModel> model);
@@ -257,7 +255,6 @@
 
 /**
  * \ingroup mobility-test
- * \ingroup tests
  *
  * \brief Waypoint Mobility Model Test Suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/examples/mpi-test-fixtures.cc ns-3.38/src/mpi/examples/mpi-test-fixtures.cc
--- ns-3.37/src/mpi/examples/mpi-test-fixtures.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mpi/examples/mpi-test-fixtures.cc	2023-03-16 20:54:23.796869000 -0700
@@ -19,8 +19,6 @@
 
 #include "mpi-test-fixtures.h"
 
-#include "mpi.h"
-
 #include "ns3/address.h"
 #include "ns3/inet-socket-address.h"
 #include "ns3/inet6-socket-address.h"
@@ -28,6 +26,8 @@
 #include "ns3/ptr.h"
 #include "ns3/simulator.h"
 
+#include <mpi.h>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/examples/simple-distributed-empty-node.cc ns-3.38/src/mpi/examples/simple-distributed-empty-node.cc
--- ns-3.37/src/mpi/examples/simple-distributed-empty-node.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mpi/examples/simple-distributed-empty-node.cc	2023-03-16 20:54:23.796869000 -0700
@@ -64,7 +64,6 @@
  */
 
 #include "mpi-test-fixtures.h"
-#include "mpi.h"
 
 #include "ns3/core-module.h"
 #include "ns3/internet-stack-helper.h"
@@ -77,6 +76,8 @@
 #include "ns3/packet-sink-helper.h"
 #include "ns3/point-to-point-helper.h"
 
+#include <mpi.h>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("SimpleDistributedEmptyNode");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/examples/simple-distributed-mpi-comm.cc ns-3.38/src/mpi/examples/simple-distributed-mpi-comm.cc
--- ns-3.37/src/mpi/examples/simple-distributed-mpi-comm.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mpi/examples/simple-distributed-mpi-comm.cc	2023-03-16 20:54:23.796869000 -0700
@@ -55,7 +55,6 @@
  */
 
 #include "mpi-test-fixtures.h"
-#include "mpi.h"
 
 #include "ns3/core-module.h"
 #include "ns3/internet-stack-helper.h"
@@ -71,6 +70,8 @@
 #include "ns3/packet-sink.h"
 #include "ns3/point-to-point-helper.h"
 
+#include <mpi.h>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("SimpleDistributedMpiComm");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/distributed-simulator-impl.cc ns-3.38/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.37/src/mpi/model/distributed-simulator-impl.cc	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mpi/model/distributed-simulator-impl.cc	2023-03-16 20:54:23.796869000 -0700
@@ -58,25 +58,25 @@
 }
 
 uint32_t
-LbtsMessage::GetTxCount()
+LbtsMessage::GetTxCount() const
 {
     return m_txCount;
 }
 
 uint32_t
-LbtsMessage::GetRxCount()
+LbtsMessage::GetRxCount() const
 {
     return m_rxCount;
 }
 
 uint32_t
-LbtsMessage::GetMyId()
+LbtsMessage::GetMyId() const
 {
     return m_myId;
 }
 
 bool
-LbtsMessage::IsFinished()
+LbtsMessage::IsFinished() const
 {
     return m_isFinished;
 }
@@ -164,7 +164,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    /* If runnning sequential simulation can ignore lookahead */
+    /* If running sequential simulation can ignore lookahead */
     if (MpiInterface::GetSize() <= 1)
     {
         m_lookAhead = Seconds(0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/distributed-simulator-impl.h ns-3.38/src/mpi/model/distributed-simulator-impl.h
--- ns-3.37/src/mpi/model/distributed-simulator-impl.h	2022-11-01 17:37:24.679395700 -0700
+++ ns-3.38/src/mpi/model/distributed-simulator-impl.h	2023-03-16 20:54:23.796869000 -0700
@@ -76,19 +76,19 @@
     /**
      * \return transmitted count
      */
-    uint32_t GetTxCount();
+    uint32_t GetTxCount() const;
     /**
      * \return received count
      */
-    uint32_t GetRxCount();
+    uint32_t GetRxCount() const;
     /**
      * \return id which corresponds to mpi rank
      */
-    uint32_t GetMyId();
+    uint32_t GetMyId() const;
     /**
      * \return true if system is finished
      */
-    bool IsFinished();
+    bool IsFinished() const;
 
   private:
     uint32_t m_txCount;  /**< Count of transmitted messages. */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/granted-time-window-mpi-interface.h ns-3.38/src/mpi/model/granted-time-window-mpi-interface.h
--- ns-3.37/src/mpi/model/granted-time-window-mpi-interface.h	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/mpi/model/granted-time-window-mpi-interface.h	2023-03-16 20:54:23.796869000 -0700
@@ -27,13 +27,13 @@
 #ifndef NS3_GRANTED_TIME_WINDOW_MPI_INTERFACE_H
 #define NS3_GRANTED_TIME_WINDOW_MPI_INTERFACE_H
 
-#include "mpi.h"
 #include "parallel-communication-interface.h"
 
 #include "ns3/buffer.h"
 #include "ns3/nstime.h"
 
 #include <list>
+#include <mpi.h>
 #include <stdint.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/mpi-interface.h ns-3.38/src/mpi/model/mpi-interface.h
--- ns-3.37/src/mpi/model/mpi-interface.h	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/mpi/model/mpi-interface.h	2023-03-16 20:54:23.796869000 -0700
@@ -26,11 +26,11 @@
 #ifndef NS3_MPI_INTERFACE_H
 #define NS3_MPI_INTERFACE_H
 
-#include "mpi.h"
-
 #include <ns3/nstime.h>
 #include <ns3/packet.h>
 
+#include <mpi.h>
+
 namespace ns3
 {
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/mpi-receiver.cc ns-3.38/src/mpi/model/mpi-receiver.cc
--- ns-3.37/src/mpi/model/mpi-receiver.cc	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/mpi/model/mpi-receiver.cc	2023-03-16 20:54:23.796869000 -0700
@@ -18,7 +18,7 @@
 /**
  * \file
  * \ingroup mpi
- * ns3::MpiReciver implementation,
+ * ns3::MpiReceiver implementation,
  * provides an interface to aggregate to MPI-compatible NetDevices.
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/null-message-mpi-interface.h ns-3.38/src/mpi/model/null-message-mpi-interface.h
--- ns-3.37/src/mpi/model/null-message-mpi-interface.h	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/mpi/model/null-message-mpi-interface.h	2023-03-16 20:54:23.796869000 -0700
@@ -26,13 +26,13 @@
 #ifndef NS3_NULLMESSAGE_MPI_INTERFACE_H
 #define NS3_NULLMESSAGE_MPI_INTERFACE_H
 
-#include "mpi.h"
 #include "parallel-communication-interface.h"
 
 #include <ns3/buffer.h>
 #include <ns3/nstime.h>
 
 #include <list>
+#include <mpi.h>
 
 namespace ns3
 {
@@ -72,7 +72,7 @@
     MPI_Comm GetCommunicator() override;
 
   private:
-    /**
+    /*
      * The null message implementation is a collaboration of several
      * classes.  Methods that should be invoked only by the
      * collaborators are private to restrict use.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/model/parallel-communication-interface.h ns-3.38/src/mpi/model/parallel-communication-interface.h
--- ns-3.37/src/mpi/model/parallel-communication-interface.h	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/mpi/model/parallel-communication-interface.h	2023-03-16 20:54:23.796869000 -0700
@@ -27,14 +27,13 @@
 #ifndef NS3_PARALLEL_COMMUNICATION_INTERFACE_H
 #define NS3_PARALLEL_COMMUNICATION_INTERFACE_H
 
-#include "mpi.h"
-
 #include <ns3/buffer.h>
 #include <ns3/nstime.h>
 #include <ns3/object.h>
 #include <ns3/packet.h>
 
 #include <list>
+#include <mpi.h>
 #include <stdint.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/mpi/test/mpi-test-suite.cc ns-3.38/src/mpi/test/mpi-test-suite.cc
--- ns-3.37/src/mpi/test/mpi-test-suite.cc	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/mpi/test/mpi-test-suite.cc	2023-03-16 20:54:23.796869000 -0700
@@ -43,7 +43,8 @@
                 const std::string program,
                 const std::string dataDir,
                 const int ranks,
-                const std::string args = "");
+                const std::string args = "",
+                const bool shouldNotErr = true);
 
     /** Destructor */
     ~MpiTestCase() override
@@ -75,8 +76,9 @@
                          const std::string program,
                          const std::string dataDir,
                          const int ranks,
-                         const std::string args /* = "" */)
-    : ExampleAsTestCase(name, program, dataDir, args),
+                         const std::string args /* = "" */,
+                         const bool shouldNotErr /* = true */)
+    : ExampleAsTestCase(name, program, dataDir, args, shouldNotErr),
       m_ranks(ranks)
 {
 }
@@ -114,10 +116,11 @@
                  const std::string dataDir,
                  const int ranks,
                  const std::string args = "",
-                 const TestDuration duration = QUICK)
+                 const TestDuration duration = QUICK,
+                 const bool shouldNotErr = true)
         : TestSuite(name, EXAMPLE)
     {
-        AddTestCase(new MpiTestCase(name, program, dataDir, ranks, args), duration);
+        AddTestCase(new MpiTestCase(name, program, dataDir, ranks, args, shouldNotErr), duration);
     }
 
 }; // class MpiTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/examples/colors-link-description.cc ns-3.38/src/netanim/examples/colors-link-description.cc
--- ns-3.37/src/netanim/examples/colors-link-description.cc	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/examples/colors-link-description.cc	2023-03-16 20:54:23.800869200 -0700
@@ -30,17 +30,17 @@
 AnimationInterface* pAnim = nullptr;
 
 /// RGB structure
-struct rgb
+struct Rgb
 {
     uint8_t r; ///< red
     uint8_t g; ///< green
     uint8_t b; ///< blue
 };
 
-struct rgb colors[] = {
+Rgb colors[] = {
     {255, 0, 0}, // Red
     {0, 255, 0}, // Blue
-    {0, 0, 255}  // Green
+    {0, 0, 255}, // Green
 };
 
 void
@@ -72,7 +72,7 @@
     {
         index = 0;
     }
-    struct rgb color = colors[index];
+    Rgb color = colors[index];
     for (uint32_t nodeId = 4; nodeId < 12; ++nodeId)
     {
         pAnim->UpdateNodeColor(nodeId, color.r, color.g, color.b);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/examples/resources-counters.cc ns-3.38/src/netanim/examples/resources-counters.cc
--- ns-3.37/src/netanim/examples/resources-counters.cc	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/examples/resources-counters.cc	2023-03-16 20:54:23.800869200 -0700
@@ -29,18 +29,18 @@
 
 AnimationInterface* pAnim = nullptr;
 
-/// RGB struture
-struct rgb
+/// RGB structure
+struct Rgb
 {
     uint8_t r; ///< red
     uint8_t g; ///< green
     uint8_t b; ///< blue
 };
 
-struct rgb colors[] = {
+Rgb colors[] = {
     {255, 0, 0}, // Red
     {0, 255, 0}, // Blue
-    {0, 0, 255}  // Green
+    {0, 0, 255}, // Green
 };
 
 uint32_t resourceId1;
@@ -96,7 +96,7 @@
     {
         index = 0;
     }
-    struct rgb color = colors[index];
+    Rgb color = colors[index];
     for (uint32_t nodeId = 4; nodeId < 12; ++nodeId)
     {
         pAnim->UpdateNodeColor(nodeId, color.r, color.g, color.b);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/examples/uan-animation.cc ns-3.38/src/netanim/examples/uan-animation.cc
--- ns-3.37/src/netanim/examples/uan-animation.cc	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/examples/uan-animation.cc	2023-03-16 20:54:23.804869200 -0700
@@ -95,7 +95,7 @@
 }
 
 void
-NetAnimExperiment::UpdatePositions(NodeContainer& nodes)
+NetAnimExperiment::UpdatePositions(NodeContainer& nodes) const
 {
     NS_LOG_DEBUG(Simulator::Now().As(Time::S) << " Updating positions");
     NodeContainer::Iterator it = nodes.Begin();
@@ -304,4 +304,6 @@
 
     per = nullptr;
     sinr = nullptr;
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/examples/uan-animation.h ns-3.38/src/netanim/examples/uan-animation.h
--- ns-3.37/src/netanim/examples/uan-animation.h	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/examples/uan-animation.h	2023-03-16 20:54:23.804869200 -0700
@@ -47,7 +47,7 @@
      * Update positions function
      * \param nodes the collection of nodes
      */
-    void UpdatePositions(NodeContainer& nodes);
+    void UpdatePositions(NodeContainer& nodes) const;
     /// Reset data function
     void ResetData();
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/model/animation-interface.cc ns-3.38/src/netanim/model/animation-interface.cc
--- ns-3.37/src/netanim/model/animation-interface.cc	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/model/animation-interface.cc	2023-03-16 20:54:23.804869200 -0700
@@ -301,7 +301,7 @@
 }
 
 bool
-AnimationInterface::IsStarted()
+AnimationInterface::IsStarted() const
 {
     return m_started;
 }
@@ -377,6 +377,12 @@
 }
 
 void
+AnimationInterface::UpdateNodeSize(Ptr<Node> n, double width, double height)
+{
+    UpdateNodeSize(n->GetId(), width, height);
+}
+
+void
 AnimationInterface::UpdateNodeSize(uint32_t nodeId, double width, double height)
 {
     AnimationInterface::NodeSize s = {width, height};
@@ -605,13 +611,13 @@
     std::vector<std::string> elements;
     std::size_t pos1 = 0;
     std::size_t pos2;
-    while (pos1 != context.npos)
+    while (pos1 != std::string::npos)
     {
         pos1 = context.find('/', pos1);
         pos2 = context.find('/', pos1 + 1);
         elements.push_back(context.substr(pos1 + 1, pos2 - (pos1 + 1)));
         pos1 = pos2;
-        pos2 = context.npos;
+        pos2 = std::string::npos;
     }
     return elements;
 }
@@ -1498,7 +1504,7 @@
 }
 
 uint64_t
-AnimationInterface::GetTracePktCount()
+AnimationInterface::GetTracePktCount() const
 {
     return m_currentPktCount;
 }
@@ -2193,7 +2199,7 @@
 void
 AnimationInterface::CheckMaxPktsPerTraceFile()
 {
-    // Start a new trace file if the current packet count exceeded nax packets per file
+    // Start a new trace file if the current packet count exceeded max packets per file
     ++m_currentPktCount;
     if (m_currentPktCount <= m_maxPktsPerFile)
     {
